/*********************************************************************
 *
 *   *** HAPPy Pascal Compiler ***
 *      [U`̎葱֐̌ďo 
 *  
 *    void calluser(Set fsys, ctp *fcp) ;
 *
 *             Copyright (c) H.Asano 1992
 *
 *********************************************************************/

#define EXTERN extern
#include "pascomp.h"
#include "pcpcd.h"

extern void expression(Set) ;
extern void selector(Set,ctp*) ;
extern ctp  *searchid(Set)  ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *orset(Set*,Set*);
extern void enterid(ctp*)    ;
extern ctp  *mkctp(char*,enum idclass,stp*,ctp*) ;
extern void pcerr(int,char*) ;
extern void insymbol(void)   ;
extern boolean compatible(stp*,stp*) ;
extern boolean assigncompati(stp*,stp*) ;
extern int align(stp*,int)   ;
extern void gen0(enum pcdmnc) ;
extern void gen0t(enum pcdmnc,stp*) ;
extern void gen1(enum pcdmnc,int) ;
extern void gen2t(enum pcdmnc, stp*,int,int);
extern void gencupent(enum pcdmnc,int,int) ; 
extern void genjump(enum pcdmnc,int) ;
extern void genldc(char,long) ;
extern void load(void)        ;
extern void loadaddress(void) ;
extern void checkbounds(stp*,int) ;
extern void skip(Set) ;

static int  pfparm(ctp *) ;
static int actualparm(Set,ctp*) ;
static boolean congruity(ctp*,ctp*) ;

/**********************************************/
/* calluser() : [U`̎葱֐̌ďo */
/**********************************************/
void calluser(Set fsys,ctp *fcp)
{
  ctp *nxt ;
  enum idkind lkind ;
  int locpar = 0;                       /* X^bNɂ̂̃TCY*/
  boolean err126 = false ;

     lkind = fcp->n.pf.sd.d.pfkind ;    /* actual / formal            */

     if(lkind == actual) {              /* 葱֐̌ďo̎  */
      gen1(iMST,level-fcp->n.pf.sd.d.pflev) ; /* mst        */
      nxt = fcp->next ;
     }
     else {                             /* 葱֐̌ďo̎  */
      gen2t(iLOD,nilptr,level-fcp->n.pf.sd.d.pflev,
                fcp->n.pf.sd.d.af.f.levadr) ; /* loda  mark           */
      gen0(iMSI) ;                            /*  msi                 */
      nxt = fcp->n.pf.sd.d.af.f.prm ;
     }

     if(sy ==lparent) {
      do {
       insymbol() ;
       if(!nxt && !err126) {
        pcerr(126,"") ;                 /* Ɖ̐Ⴄ   */
        err126 = true ;
       }
       if(nxt && 
        ((nxt->klass==proc) || (nxt->klass==func)))
        locpar += pfparm(nxt) ;         /* ֐葱        */
       else                             /* lϐ            */
        locpar += actualparm(fsys,nxt) ;
       locpar = align(parmptr,locpar) ;

       if(nxt) nxt = nxt->next ;        /* ̈                   */

      } while(sy==comma) ;

      if(sy == rparent) insymbol() ;
      else pcerr(4,"") ;                /* ) Ȃ                   */
     }

     if(nxt && !err126) pcerr(126,"") ; /* Ɖ̐Ⴄ   */
     

     if(lkind == actual)                /* 葱֐̌ďo̎  */
      gencupent(iCUP,locpar,fcp->n.pf.sd.d.af.a.pfname);/* cupߐ*/
     else {                             /* 葱֐̌ďo̎  */
      gen2t(iLOD,nilptr,level-fcp->n.pf.sd.d.pflev,
                         fcp->n.pf.sd.d.af.f.adradr) ; /*loda sadr */
      gen1(iCUI,locpar) ;               /* cuiߐ                */
     }

     gattr.typtr = fcp->idtype ;        /* 葱֐̌^            */
}

/********************************************/
/* actualparm() : lϐp[^     */
/********************************************/
static int actualparm(Set fsys,ctp *fnxt)
{
  stp *lsp ;
  ctp *lcp ;
  int locpar = 0 ;
  Set ws,ws2 ;

     mkset(&ws,comma,rparent,-1) ;
     mkset(&ws2,vars,field,-1)   ;
     if(fnxt) {                         /*                  */
     
      lsp = fnxt->idtype ;
      if(fnxt->n.v.vkind == actual) {   /* l̎                 */
       expression(ws) ;                 /* ̏                   */
       if(!assigncompati(lsp,gattr.typtr)) /* \`FbN      */
        pcerr(155,"") ;                 /* s\                 */
       if(lsp->form <= power) {         /* XJ͈͌^|C^W*/
        load() ;                        /*   load                 */
        if(lsp->form == power)
         checkbounds(lsp,8) ;           /*  Wl͈̔̓`FbN      */
        else
         checkbounds(lsp,7) ;           /*  ^͈̔̓`FbN      */ 
        if((lsp == realptr) &&          /*   錾real^           */
          compatible(gattr.typtr,intptr)) {  /* integer̎   */
         gen0(iFLT) ;                   /*    fltߐ             */
         gattr.typtr = realptr ;
        }
        locpar = lsp->size ;            /* X^bNɐςވTCYvZ*/
       }
       else {                           /* z񤃌R[h              */
        loadaddress() ;                 /*   loadaddress          */
        locpar = parmsize ;             /*   AhX̃TCY       */
       }
      } 
      else  {                           /* ϐ̎               */
       if(sy == ident) {
        lcp = searchid(ws2) ;           /* ϐtB[hT  */
        insymbol() ;
        selector(ws,lcp) ;
        if(lsp != gattr.typtr)          /*   ^Ⴄ                 */
         pcerr(142,"") ;                /*   Ǝ̌^sv */
        loadaddress() ;                 /*   loadaddress          */
        locpar = parmsize ;             /*   AhX̃TCY       */
       }
       else {
        pcerr(6,"") ;                   /* sȋLꂽ         */
        skip(ws)    ; 
       } 
      }
     }
     else expression(ws) ;            /* ȂƂ肠
                                        ƂďĂ*/
     return(locpar) ;
}

/**************************************************/
/* pfparm() : 葱֐p[^     */
/**************************************************/
static int pfparm(ctp *fnxt)            /* fnxt:                */
{
  ctp *lcp , *lcp1;
  Set ws;

     mkset(&ws, func,proc, -1);
     lcp = searchid(ws) ;               /* 葱֐T    */
     if(lcp->klass != fnxt->klass)      /* ̎ނႤ           */
      pcerr(142,"") ;                   /* Ǝ̌^sv */
     else 
      if(lcp->n.pf.pfdeckind == standard)
       (lcp->klass==proc) ? pcerr(174,lcp->name) : pcerr(175,lcp->name);
                                        /* W葱֐͎ʖ*/
      else {
       lcp1 = (lcp->n.pf.sd.d.pfkind==actual)
                 ? lcp->next : lcp->n.pf.sd.d.af.f.prm ;
       if(!congruity(lcp1,fnxt->n.pf.sd.d.af.f.prm))
        pcerr(127,lcp->name);           /* `łȂ                 */
       else if(lcp->klass == func)
        if(lcp->idtype != fnxt->idtype)
         pcerr(173,lcp->name) ;         /* ֐̌ʂ̌^Ⴄ       */
      }

     if(lcp->n.pf.sd.d.pfkind==actual) {/* ̎                 */
      gen1(iBAS,level - lcp->n.pf.sd.d.pflev) ;/* baseAhX߂*/
      genjump(iLAP,lcp->n.pf.sd.d.af.a.pfname);/*sAhX         */
     }
     else {                             /* ̎                 */
      gen2t(iLOD,nilptr,level - lcp->n.pf.sd.d.pflev,
                         lcp->n.pf.sd.d.af.f.levadr) ; /*loda `*/
      gen2t(iLOD,nilptr,level - lcp->n.pf.sd.d.pflev,
                         lcp->n.pf.sd.d.af.f.adradr) ; /*loda sadr */
     }  

     insymbol() ;
     return(2)  ; /* b  AhXTCY~2ԂΗǂ */
}

/******************************************/
/* congruity() : p[^̓``FbN */
/******************************************/
static boolean congruity(ctp *fcp1,ctp *fcp2)
{
     while(fcp1 && fcp2) {              /* 2Ƃ        */
      if(fcp1->klass != fcp2->klass)    /* ̎ނႤ           */
       return(false) ;
      if(fcp1->klass == vars) {         /* lϐ̎                */
       if(fcp1->linkno != fcp2->linkno) /* Oт̐Ⴄ         */
        return(false) ;
       if(fcp1->n.v.vkind != fcp2->n.v.vkind) /* lϐ̎ނႤ  */
        return(false) ;
       if(fcp1->idtype != fcp2->idtype) /* ^Ⴄ                   */
        return(false) ;
      }
      else {
       if(fcp1->klass == func)          /* ֐̎               */
        if(fcp1->idtype != fcp2->idtype)/*  ֐̌ʌ^Ⴄ        */
         return(false);
       if(!congruity(fcp1->n.pf.sd.d.af.f.prm, fcp2->n.pf.sd.d.af.f.prm))               return(false) ;            /* ꂼ̉ɂă`FbN*/
      }
      fcp1 = fcp1->next ;
      fcp2 = fcp2->next ;
     }
     if((!fcp1) && (!fcp2)) return(true) ;/* ƂȂOK   */
     else                   return(false);/* Ⴆ          NG   */
}
